<template>
  <div id="searchbox" class="searchbox">
    <div class="dropdown is-active is-right">
      <div class="field has-addons" ref="input">
        <p class="control has-icons-left">
          <input
            class="input"
            v-model="typedString"
            @keyup="debounceSearch"
            @keyup.esc="escPressed"
            @keydown.down.prevent="keyArrows('down')"
            @keydown.up.prevent="keyArrows('up')"
            @keydown.enter="enterPressed"
            ref="input"
            type="text"
            placeholder="Search"
          />
          <span class="icon is-small is-left">
            <svg
              role="img"
              xmlns="http://www.w3.org/2000/svg"
              width="24"
              height="24"
              viewBox="0 0 24 24"
              aria-labelledby="searchIconTitle searchIconDesc"
            >
              <title id="searchIconTitle">Search</title>
              <desc id="searchIconDesc">Icon of a magnifying glass</desc>
              <path d="M14.4121122,14.4121122 L20,20" />
              <circle cx="10" cy="10" r="6" />
            </svg>
          </span>
        </p>
        <p v-if="typedString.length > 0" class="control">
          <a class="button is-white">
            <span v-on:click="reset()" class="icon is-small">
              <svg
                role="img"
                xmlns="http://www.w3.org/2000/svg"
                width="24"
                height="24"
                viewBox="0 0 24 24"
                aria-labelledby="closeIconTitle closeIconDesc"
                stroke="#3593d1"
                stroke-width="1.5"
                stroke-linecap="square"
                stroke-linejoin="miter"
                fill="none"
                color="#3593d1"
              >
                <title id="closeIconTitle">Close</title>
                <desc id="closeIconDesc">Icon of a cross (x)</desc>
                <path
                  d="M6.34314575 6.34314575L17.6568542 17.6568542M6.34314575 17.6568542L17.6568542 6.34314575"
                />
              </svg>
            </span>
          </a>
        </p>
      </div>
      <transition name="fade">
        <div class="dropdown-menu" id="dropdown-menu" role="menu" v-show="isActive" ref="dropdown">
          <div
            class="dropdown-content"
            v-if="filteredItems.hasOwnProperty('services')"
            v-show="isActive"
          >
            <template v-for="(item, i) in filteredItems.services">
              <router-link
                class="dropdown-item"
                v-bind:key="item.id"
                v-bind:class="{'is-active': i === arrowCounter && setHovered(item) }"
                tag="a"
                :to="{name: 'service-overview', params:{id: item.id}}"
              >
                <p @mouseover="onFocus">{{item.name}}</p>
                <small>{{`${item.description.slice(0,60)}...`}}</small>
              </router-link>
            </template>
            <hr
              v-if="filteredItems.hasOwnProperty('instances') && filteredItems.hasOwnProperty('services')"
              class="dropdown-divider"
            />
            <div
              class="dropdown-item has-text-weight-semibold"
              v-if="filteredItems.hasOwnProperty('instances')"
            >Instances</div>
            <a
              v-for="(item, i) in filteredItems.instances"
              class="dropdown-item"
              v-bind:class="{'is-active': i + filteredItems.services.length === arrowCounter && setHovered(item)}"
              v-bind:key="item.instace_uuid"
              v-bind:href="item.dashboard_url"
            >
              <small>{{item.dashboard_url}}</small>
            </a>
          </div>
        </div>
      </transition>
    </div>
  </div>
</template>

<script lang="ts">
import { Component, Prop, Vue, Watch } from "vue-property-decorator";

import _ from "lodash";

interface ResultItem {
  id?: string;
  name?: string;
  description?: string;
  dashboard_url?: string;
}

interface ResultList {
  [key: string]: any;
  services?: ResultItem[];
  instances?: ResultItem[];
}

@Component
export default class SearchInput extends Vue {
  private typedString: string = "";
  private searchString: string = "";
  private isActive: boolean = false;
  private arrowCounter: number = -1;
  private hovered: ResultItem | null = null;

  get filteredItems() {
    let search = this.searchString;
    let searchResults: ResultList = {};
    let services: ResultItem[];
    let instances: ResultItem[];

    if (search.length > 0) {
      let services = this.$store.getters["catalog/getServiceBySearch"](search);
      if (services.length > 0) {
        searchResults.services = services;
        instances = this.matchingInstances(services);
        if (instances.length > 0) {
          searchResults.instances = instances;
        }
      }
      this.arrowCounter = -1;
      this.hovered = null;
      this.isActive =
        this.typedString.length > 0 && searchResults.hasOwnProperty("services");
    }
    return searchResults;
  }

  matchingInstances(services: ResultItem[]) {
    let res: ResultItem[] = [];
    for (let service of services) {
      let instance = this.$store.getters["catalog/getInstancesForServiceUUID"](
        service.id
      );
      if (instance) res.push(instance);
    }
    return res;
  }

  reset() {
    this.isActive = false;
    this.typedString = "";
    this.searchString = "";
    this.hovered = null;
    this.arrowCounter = -1;
  }

  debounceSearch() {
    _.debounce(() => {
      this.searchString = this.typedString;
    }, 1000)();
  }

  setHovered(option: ResultItem) {
    if (option) {
      this.hovered = option;
      return true;
    }
    return false;
  }

  keyArrows(key: string) {
    let dropdownSize = 0;
    for (const k of Object.keys(this.filteredItems)) {
      if (this.filteredItems.hasOwnProperty(k)) {
        dropdownSize = dropdownSize + this.filteredItems[k].length;
      }
    }

    if (this.isActive) {
      if (key == "down") {
        if (this.arrowCounter < dropdownSize - 1) {
          this.arrowCounter = this.arrowCounter + 1;
        }
      }
      if (key == "up") {
        if (this.arrowCounter > 0) {
          this.arrowCounter = this.arrowCounter - 1;
        }
      }
    }
  }

  enterPressed() {
    if (this.arrowCounter !== -1 && this.hovered) {
      if (this.hovered.dashboard_url) {
        window.open(this.hovered.dashboard_url, "_blank");
        this.reset();
      } else {
        this.$router.push({
          name: "service-overview",
          params: { id: String(this.hovered.id) }
        });
        this.reset();
      }
    }
  }

  escPressed() {
    this.reset();
    return;
  }

  onFocus() {
    this.arrowCounter = -1;
    this.hovered = null;
  }

  handleClickOutside(evt: Event) {
    if (evt.target) {
      if (!this.$el.contains(<Node>evt.target)) {
        this.reset();
      }
    }
  }

  private mounted() {
    document.addEventListener("click", this.handleClickOutside);
  }

  private destroyed() {
    document.removeEventListener("click", this.handleClickOutside);
  }
}
</script>
<style lang="scss" scoped>
[v-cloak] {
  display: none;
}

.dropdown-menu {
  width: 25rem;
}

/*
* Remove defaul margin-botton value of fiel class
 */
.field:not(:last-child) {
  margin-bottom: 0;
}

.fade-enter-active {
  transition: all 0.5s ease;
}
.fade-leave-active {
  transition: all 0.5s cubic-bezier(1, 0.5, 0.8, 1);
}
.fade-enter,
.fade-leave-to {
  transform: translateY(10px);
  opacity: 0;
}
</style>
